require 'fettle/configuration'
require 'fettle/check_result'
require 'fettle/liveness_check_result'

module Fettle
  class Checker
    attr_reader :tag
    private :tag

    def initialize(tag)
      @tag = tag
    end

    def self.run(tag: nil)
      new(tag).run
    end

    def run
      check_result_class.new(
        checks.map(&method(:run_check)).all?
      )
    end

    private

    def run_check(check)
      check.call
    rescue StandardError
      false
    end

    def checks
      Configuration.checks
    end

    def check_result_class
      {
        'liveness' => LivenessCheckResult
      }.fetch(tag.to_s, CheckResult)
    end
  end
end
