require 'fettle'

module Fettle
  module Checks
    class ActiveRecordCheck
      class << self
        def call
          return true unless defined?(ActiveRecord)

          check_connection!
          check_migrations!

          true
        end

        def check_connection!
          ActiveRecord::Base.connection

          ActiveRecord::Base.connected? ||
            raise(FailedCheck, 'Failed to establish database connection')
        end

        def check_migrations!
          ActiveRecord::Migration.check_pending!
        rescue
          raise(FailedCheck, 'Database migrations are pending')
        end
      end

    end
  end
end
