module Fettle
  module Configuration
    module_function

    def configure
      yield self
    end

    def add_check(check)
      require "fettle/checks/#{check}_check"

      klass = Fettle::Checks.const_get(
        "#{check}_check".split('_').map(&:capitalize).join('')
      )

      checks << klass
    end

    def checks
      @checks ||= []
    end

    def clear_checks!
      @checks = []
    end
  end
end
